package org.simantics.scl.compiler.elaboration.expressions;

import org.simantics.scl.compiler.common.exceptions.InternalCompilerError;
import org.simantics.scl.compiler.compilation.CompilationContext;
import org.simantics.scl.compiler.internal.codegen.references.IVal;
import org.simantics.scl.compiler.internal.codegen.writer.CodeWriter;

public abstract class SimplifiableExpression extends Expression {

    public SimplifiableExpression() {
    }
    
    public SimplifiableExpression(long loc) {
        super(loc);
    }

    @Override
    public IVal toVal(CompilationContext context, CodeWriter w) {
        throw new InternalCompilerError("Cannot generate code for " + getClass().getSimpleName() + ".");
    }
}
